<?php
/**
 * @version	Id: socialshareandvotebutton.php $
 * @package	Joomla
 * @subpackage	Content
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license	GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 */

// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

/**
 * Socialshareandvotebutton Plugin
 *
 * @package		Joomla
 * @subpackage	Content
 * @since 		1.5
 */
class plgContentSocialshareandvotebutton extends JPlugin
{

	/**
	 * Constructor
	 *
	 * For php4 compatability we must not use the __constructor as a constructor for plugins
	 * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
	 * This causes problems with cross-referencing necessary for the observer design pattern.
	 *
	 * @param object $subject The object to observe
	 * @param object $params  The object that holds the plugin parameters
	 * @since 1.5
	 */
	function plgContentSocialshareandvotebutton( &$subject, $params )
	{
		parent::__construct( $subject, $params );                            
                
                // load plugin parameters
                $this->_plugin = JPluginHelper::getPlugin( 'content', 'socialshareandvotebutton' );
                $this->_params = new JParameter( $this->_plugin->params );

                // return if params are empty
                if(!$this->_params){ return;}
                $this->_weights = array();  // will hold the weights for array
                //basic params
                $this->_skipitemid      = $this->_params->def('skipitemid',''); //show/hide for specific itemid
                $this->_curitemid       = JRequest::getCmd('Itemid');
                $this->_skipcat         = $this->_params->def( 'skipcat', '' ); //show hide for specific categories
                $this->_skipsec         = $this->_params->def( 'skipsec', '' ); //show hide for specific categories                
                $this->_skipfront       = $this->_params->def( 'skipfront', 1 ); //show/hide in front page
                $this->_skipcatview     = $this->_params->def('skipcatview',0); // show/hide in category view
                $this->_skipsecview     = $this->_params->def('skipsecview',0); //show/hide in section view
                
                                            
                                
                

                

                //facebook share                
                $this->_fb = $this->_params->def( 'fbshare', 0 );
                $this->_fbpos = $this->_params->def( 'fbsharepos', 1 );
                $this->_fbstyle = $this->_params->def( 'fbsharestyle', 'normal' );
                $this->_fbweight = $this->_params->def( 'fbshareweight', 100 );
                $this->_weights['fb'] = $this->_fbweight;
                //fbshare.me
                $this->_fbme = $this->_params->def( 'fbmeshare', 0 );
                $this->_fbmepos = $this->_params->def( 'fbmesharepos', 1 );
                $this->_fbmestyle = $this->_params->def( 'fbmesharestyle', 'normal' );
                $this->_fbmeweight = $this->_params->def( 'fbmeshareweight', 100 );
                $this->_weights['fbme'] = $this->_fbmeweight;

                //twitter                
                $this->_twitter = $this->_params->def( 'twittershare', 0 );
                $this->_twitterpos = $this->_params->def('twittersharepos', 1 );
                $this->_twitterstyle = $this->_params->def('twittersharestyle', 'normal' );
                $this->_twitterweight = $this->_params->def('twittershareweight', 100 );
                $this->_twittersource = $this->params->def('twittersource','');
                $this->_weights['twitter'] = $this->_twitterweight;

                //tweetmeme.com
                $this->_tmeme = $this->_params->def( 'tmemeshare', 0 );
                $this->_tmemepos = $this->_params->def('tmemesharepos', 1 );
                $this->_tmemestyle = $this->_params->def('tmemesharestyle', 'normal' );
                $this->_tmemeweight = $this->_params->def('tmemeshareweight', 100 );
                $this->_tmemesource = $this->params->def('tmemesource','tweetmeme');
                $this->_weights['tmeme'] = $this->_tmemeweight;

                //topsy.com
                $this->_topsyshare = $this->_params->def( 'topsyshare', 0 );
                $this->_topsysharepos = $this->_params->def('topsysharepos', 1 );
                $this->_topsysharestyle = $this->_params->def('topsysharestyle', 'normal' );
                $this->_topsyshareweight = $this->_params->def('topsyshareweight', 100 );
                $this->_topsysource = $this->params->def('topsysource','topsy');
                $this->_weights['topsyshare'] = $this->_topsyshareweight;

                //google buzz
                $this->_gbuzz = $this->_params->def( 'gbuzzshare', 0 );
                $this->_gbuzzpos = $this->_params->def( 'gbuzzsharepos', 1 );
                $this->_gbuzzstyle = $this->_params->def( 'gbuzzsharestyle', 'normal' );
                $this->_gbuzzweight = $this->_params->def( 'gbuzzshareweight', 100 );
                $this->_weights['gbuzz'] = $this->_gbuzzweight;

                //yahoo buzz
                $this->_ybuzz = $this->_params->def( 'ybuzzshare', 0 );
                $this->_ybuzzpos = $this->_params->def( 'ybuzzsharepos', 1 );
                $this->_ybuzzstyle = $this->_params->def( 'ybuzzsharestyle', 'normal' );
                $this->_ybuzzweight = $this->_params->def( 'ybuzzshareweight', 100 );
                $this->_weights['ybuzz'] = $this->_ybuzzweight;

                //digg                             
                $this->_diggshare = $this->_params->def( 'diggshare', 0 );
                $this->_diggsharepos = $this->_params->def( 'diggsharepos', 1 );
                $this->_diggsharestyle = $this->_params->def( 'diggsharestyle', 'normal' );
                $this->_diggshareweight = $this->_params->def( 'diggshareweight', 100 );
                $this->_weights['diggshare'] = $this->_diggshareweight;

                if($this->_diggshare)
                {
                    $doc =& JFactory::getDocument();
                    $doc->addScript("http://widgets.digg.com/buttons.js");
                }

                //stumble                
                $this->_stumbbleshare = $this->_params->def( 'stumbbleshare', 0 );
                $this->_stumbblesharepos = $this->_params->def( 'stumbblesharepos', 1 );
                $this->_stumblesharestyle = $this->_params->def( 'stumblesharestyle', 'normal' );
                $this->_stumbbleshareweight = $this->_params->def( 'stumbbleshareweight', 100 );
                $this->_weights['stumbbleshare'] = $this->_stumbbleshareweight;

                //delcious
                $this->_delshare = $this->_params->def( 'delshare', 0 );
                $this->_delsharepos = $this->_params->def( 'delsharepos', 1 );
                $this->_delsharestyle = $this->_params->def( 'delsharestyle', 'normal' );
                $this->_delshareweight = $this->_params->def( 'delshareweight', 100 );
                $this->_weights['delshare'] = $this->_delshareweight;

                //dzone
                $this->_dzoneshare = $this->_params->def( 'dzoneshare', 0 );
                $this->_dzonesharepos = $this->_params->def( 'dzonesharepos', 1 );
                $this->_dzonesharestyle = $this->_params->def( 'dzoneharestyle', 'normal' );
                $this->_dzoneshareweight = $this->_params->def( 'dzoneshareweight', 100 );
                $this->_weights['dzoneshare'] = $this->_dzoneshareweight;

                //fblike button

                $this->_fblike = $this->_params->def( 'fblike', 0 );
                $this->_fblikepos = $this->_params->def( 'fblikepos', 4 );
                $this->_fblikestyle = $this->_params->def( 'fblikestyle', 'standard' );
                $this->_fblikeverb = $this->_params->def( 'fblikeverb', 'like' );
                $this->_fblikecolor = $this->_params->def( 'fblikecolor', 'light' );
                $this->_fblikewidth = $this->_params->def('fblikewidth',450);
                $this->_fblikeheight = $this->_params->def('fblikeheight',80);


	}

        static function cmp($a, $b)
        {
            //var_dump($a);
            //var_dump($b);
            if ($a == $b) {
                return 0;
            }
            return ($a < $b) ? -1 : 1;
        }

	/**
	 * Socialshareandvotebutton prepare content method
	 *
	 * Method is called by the view
	 *
	 * @param 	object		The article object.  Note $article->text is also available
	 * @param 	object		The article params
	 * @param 	int			The 'page' number
	 */
	function onPrepareContent( &$article, &$params, $limitstart )
	{            
		global $mainframe;

                // return if params are empty
                if(!$this->_params){ return;}

                

                //itemid to ignore
                if($this->_skipitemid != '' && $this->_curitemid != '')
                {
                    $exc_itemids = explode (",", $this->_skipitemid);
                    foreach ($exc_itemids as $iid){if ($this->_curitemid == $iid){ return; }}
                }

                if((JRequest::getCmd('view') == 'frontpage') && !$this->_skipfront)
                {
                   return;
                }



                if((JRequest::getCmd('view') == 'category') && !$this->_skipcatview)
                {
                   return;
                }

                if((JRequest::getCmd('view') == 'section') && !$this->_skipsecview)
                {
                   return;
                }

                //section to ignore
                if($this->_skipsec != '' && $article->sectionid !=  NULL )
                {
                    $exc_sec = explode (",", $this->_skipsec);
                    foreach ($exc_sec as $sid){if ($article->sectionid == $sid){ return; }}
                }
                
                //category to ignore
                if($this->_skipcat != '' && $article->catid !=  NULL)
                {
                    $exc_cat = explode (",", $this->_skipcat);
                    foreach ($exc_cat as $cid){if ($article->catid == $cid){ return; }}
                }
                
                //adding stylesheet
                JHTML::stylesheet('style.css','plugins/content/socialshareandvotebutton/');
                
                $uri		= JFactory::getURI();
		$sitehost	= $uri->toString( array ('scheme', 'host', 'port' ) );

                $l = JRoute::_(ContentHelperRoute::getArticleRoute($article->slug, $article->catslug, $article->sectionid));
                
                $link = $sitehost.$l;

                $title = $article->title;

                               
                $output = '';
                $output_t = '';
                $output_r = '';
                $output_b = '';
                $output_l = '';

                
                uasort($this->_weights, array(&$this,'cmp'));
                foreach ($this->_weights as $key => $value)
                {
                    //var_dump($key);
                    //facebook share
                    if($this->_fb && $key == 'fb')
                    {
                        switch ($this->_fbpos)
                        {
                            case 1://before content
                                $output_t .= Printbutton::show_fb_button($link, $title, $this->_fbpos, $this->_fbstyle);
                                break;
                            case 2://left
                                $output_l .= Printbutton::show_fb_button($link, $title, $this->_fbpos, $this->_fbstyle);
                                break;
                            case 3://right
                                $output_r .= Printbutton::show_fb_button($link, $title, $this->_fbpos, $this->_fbstyle);
                                break;
                            case 4://after content
                                $output_b .= Printbutton::show_fb_button($link, $title, $this->_fbpos, $this->_fbstyle);
                                break;
                        }
                        //$output .=  Printbutton::show_fb_button($link, $title, $this->_fbpos, $this->_fbstyle);
                    }

                    //http://fbshare.me
                    if($this->_fbme && $key == 'fbme')
                    {
                        switch ($this->_fbmepos)
                        {
                            case 1:
                                $output_t .=  Printbutton::show_fbme_button($link, $title, $this->_fbmepos, $this->_fbmestyle);
                                break;
                            case 2:
                                $output_l .=  Printbutton::show_fbme_button($link, $title, $this->_fbmepos, $this->_fbmestyle);
                                break;
                            case 3:
                                $output_r .=  Printbutton::show_fbme_button($link, $title, $this->_fbmepos, $this->_fbmestyle);
                                break;
                            case 4:
                                $output_b .=  Printbutton::show_fbme_button($link, $title, $this->_fbmepos, $this->_fbmestyle);
                                break;
                        }
                        //$output .=  Printbutton::show_fbme_button($link, $title, $this->_fbmepos, $this->_fbmestyle);
                    }
                    //http://twitter.com
                    if($this->_twitter && $key == 'twitter')
                    {
                        $source = $this->_twittersource;
                        switch($this->_twitterpos)
                        {
                            case 1:
                                $output_t .=  Printbutton::show_twitter_button($link, $title, $source, $this->_twitterpos, $this->_twitterstyle);
                                break;
                            case 2:
                                $output_l .=  Printbutton::show_twitter_button($link, $title, $source, $this->_twitterpos, $this->_twitterstyle);
                                break;
                            case 3:
                                $output_r .=  Printbutton::show_twitter_button($link, $title, $source, $this->_twitterpos, $this->_twitterstyle);
                                break;
                            case 4:
                                $output_b .=  Printbutton::show_twitter_button($link, $title, $source, $this->_twitterpos, $this->_twitterstyle);
                                break;
                        }
                    }

                    //http://tweetmeme.com
                    if($this->_tmeme && $key == 'tmeme')
                    {
                        $source = $this->_tmemesource;
                        switch($this->_tmemepos)
                        {
                            case 1:
                                $output_t .=  Printbutton::show_tmeme_button($link, $title, $source, $this->_tmemepos, $this->_tmemestyle);
                                break;
                            case 2:
                                $output_l .=  Printbutton::show_tmeme_button($link, $title, $source, $this->_tmemepos, $this->_tmemestyle);
                                break;
                            case 3:
                                $output_r .=  Printbutton::show_tmeme_button($link, $title, $source, $this->_tmemepos, $this->_tmemestyle);
                                break;
                            case 4:
                                $output_b .=  Printbutton::show_tmeme_button($link, $title, $source, $this->_tmemepos, $this->_tmemestyle);
                                break;
                        }
                        //$output .=  Printbutton::show_tmeme_button($link, $title, $source, $this->_tmemepos, $this->_tmemestyle);
                    }

                    //http://topsy.com
                    if($this->_topsyshare && $key == 'topsshare')
                    {
                        $source = $this->_topsysource;
                        switch($this->_topsysharepos)
                        {
                            case 1:
                                $output_t .=  Printbutton::show_topsy_button($link, $title, $source, $this->_topsysharepos, $this->_topsysharestyle);
                                break;
                            case 2:
                                $output_l .=  Printbutton::show_topsy_button($link, $title, $source, $this->_topsysharepos, $this->_topsysharestyle);
                                break;
                            case 3:
                                $output_r .=  Printbutton::show_topsy_button($link, $title, $source, $this->_topsysharepos, $this->_topsysharestyle);
                                break;
                            case 4:
                                $output_b .=  Printbutton::show_topsy_button($link, $title, $source, $this->_topsysharepos, $this->_topsysharestyle);
                                break;

                        }
                        //$output .=  Printbutton::show_topsy_button($link, $title, $source, $this->_topsysharepos, $this->_topsysharestyle);
                    }

                    //digg
                    if($this->_diggshare && $key == 'diggshare')
                    {
                        switch($this->_diggsharepos)
                        {
                            case 1:
                                $output_t .=  Printbutton::show_digg_button($link, $title, $this->_diggsharepos, $this->_diggsharestyle);
                                break;
                            case 2:
                                $output_l .=  Printbutton::show_digg_button($link, $title, $this->_diggsharepos, $this->_diggsharestyle);
                                break;
                            case 3:
                                $output_r .=  Printbutton::show_digg_button($link, $title, $this->_diggsharepos, $this->_diggsharestyle);
                                break;
                            case 4:
                                $output_b .=  Printbutton::show_digg_button($link, $title, $this->_diggsharepos, $this->_diggsharestyle);
                                break;
                        }
                        //$output .=  Printbutton::show_digg_button($link, $title, $this->_diggsharepos, $this->_diggsharestyle);
                    }
                    //delicious
                    if($this->_delshare && $key == 'delshare')
                    {
                        switch($this->_delsharepos)
                        {
                            case 1:
                                $output_t .=  Printbutton::show_del_button($link, $title, $this->_delsharepos, $this->_delsharestyle);
                                break;
                            case 2:
                                $output_l .=  Printbutton::show_del_button($link, $title, $this->_delsharepos, $this->_delsharestyle);
                                break;
                            case 3:
                                $output_r .=  Printbutton::show_del_button($link, $title, $this->_delsharepos, $this->_delsharestyle);
                                break;
                            case 4:
                                $output_b .=  Printbutton::show_del_button($link, $title, $this->_delsharepos, $this->_delsharestyle);
                                break;
                        }
                        //$output .=  Printbutton::show_del_button($link, $title, $this->_delsharepos, $this->_delsharestyle);
                    }

                    //stumble
                    if($this->_stumbbleshare && $key == 'stumbbleshare')
                    {

                        switch($this->_stumbblesharepos)
                        {
                            case 1:
                                $output_t .=  Printbutton::show_stumble_button($link, $title, $this->_stumbblesharepos, $this->_stumblesharestyle);
                                break;
                            case 2:
                                $output_l .=  Printbutton::show_stumble_button($link, $title, $this->_stumbblesharepos, $this->_stumblesharestyle);
                                break;
                            case 3:
                                $output_r .=  Printbutton::show_stumble_button($link, $title, $this->_stumbblesharepos, $this->_stumblesharestyle);
                                break;
                            case 4:
                                $output_b .=  Printbutton::show_stumble_button($link, $title, $this->_stumbblesharepos, $this->_stumblesharestyle);
                                break;
                        }
                        //$output .=  Printbutton::show_stumble_button($link, $title, $this->_stumbblesharepos, $this->_stumblesharestyle);
                    }

                    //google buzz
                    if($this->_gbuzz && $key == 'gbuzz')
                    {
                        switch($this->_gbuzzpos)
                        {
                            case 1:
                                $output_t .=  Printbutton::show_gbuzz_button($link, $title, $this->_gbuzzpos, $this->_gbuzzstyle);
                                break;
                            case 2:
                                $output_l .=  Printbutton::show_gbuzz_button($link, $title, $this->_gbuzzpos, $this->_gbuzzstyle);
                                break;
                            case 3:
                                $output_r .=  Printbutton::show_gbuzz_button($link, $title, $this->_gbuzzpos, $this->_gbuzzstyle);
                                break;
                            case 4:
                                $output_b .=  Printbutton::show_gbuzz_button($link, $title, $this->_gbuzzpos, $this->_gbuzzstyle);
                                break;
                        }
                        //$output .=  Printbutton::show_gbuzz_button($link, $title, $this->_gbuzzpos, $this->_gbuzzstyle);
                    }

                    //yahoo buzz
                    if($this->_ybuzz && $key == 'ybuzz')
                    {
                        switch($this->_ybuzzpos)
                        {
                            case 1:
                                $output_t .=  Printbutton::show_ybuzz_button($link, $title, $this->_ybuzzpos, $this->_ybuzzstyle);
                                break;
                            case 2:
                                $output_l .=  Printbutton::show_ybuzz_button($link, $title, $this->_ybuzzpos, $this->_ybuzzstyle);
                                break;
                            case 3:
                                $output_r .=  Printbutton::show_ybuzz_button($link, $title, $this->_ybuzzpos, $this->_ybuzzstyle);
                                break;
                            case 4:
                                $output_b .=  Printbutton::show_ybuzz_button($link, $title, $this->_ybuzzpos, $this->_ybuzzstyle);
                                break;
                        }
                        //$output .=  Printbutton::show_ybuzz_button($link, $title, $this->_ybuzzpos, $this->_ybuzzstyle);
                    }

                    //dzone
                    if($this->_dzoneshare && $key == 'dzoneshare')
                    {
                        switch($this->_dzonesharepos)
                        {
                            case 1:
                                $output_t .=  Printbutton::show_dzone_button($link, $title, $this->_dzonesharepos, $this->_dzonesharestyle);
                                break;
                            case 2:
                                $output_l .=  Printbutton::show_dzone_button($link, $title, $this->_dzonesharepos, $this->_dzonesharestyle);
                                break;
                            case 3:
                                $output_r .=  Printbutton::show_dzone_button($link, $title, $this->_dzonesharepos, $this->_dzonesharestyle);
                                break;
                            case 4:
                                $output_b .=  Printbutton::show_dzone_button($link, $title, $this->_dzonesharepos, $this->_dzonesharestyle);
                                break;
                        }
                        //$output .=  Printbutton::show_dzone_button($link, $title, $this->_dzonesharepos, $this->_dzonesharestyle);
                    }
                }
                //fblike

                if($this->_fblike)
                {
                    switch($this->_fblikepos)
                    {
                        case 1:
                            $output_t .=  Printbutton::show_fblike_button($link, $title, $this->_fblikepos, $this->_fblikestyle, $this->_fblikeverb, $this->_fblikecolor, $this->_fblikewidth, $this->_fblikeheight);
                            break;
                        case 4:
                            $output_b .=  Printbutton::show_fblike_button($link, $title, $this->_fblikepos, $this->_fblikestyle, $this->_fblikeverb, $this->_fblikecolor, $this->_fblikewidth, $this->_fblikeheight);
                            break;
                    }
                }

                $output_t = ($output_t != '')? '<div class="clear"></div><div class="allshare_buttons allshare_buttons_t">'.$output_t.'<div class="clear"></div></div><div class="clear"></div>':'';
                $output_l = ($output_l != '')? '<div class="allshare_buttons allshare_buttons_l">'.$output_l.'<div class="clear"></div></div>':'';
                $output_r = ($output_r != '')?'<div class="allshare_buttons allshare_button_r">'.$output_r.'<div class="clear"></div></div>':'';
                $output_b = ($output_b != '')?'<div class="clear"></div><div class="allshare_buttons allshare_button_b">'.$output_b.'<div class="clear"></div></div>':'';

                $article->text =  $output_t.$output_l.$output_r.$article->text.$output_b;
	}

	/**
	 * Socialshareandvotebutton after display title method
	 *
	 * Method is called by the view and the results are imploded and displayed in a placeholder
	 *
	 * @param 	object		The article object.  Note $article->text is also available
	 * @param 	object		The article params
	 * @param 	int		The 'page' number
	 * @return	string
	 */
	function onAfterDisplayTitle( &$article, &$params, $limitstart )
	{
		global $mainframe;

		return '';
	}

	/**
	 * Socialshareandvotebutton before display content method
	 *
	 * Method is called by the view and the results are imploded and displayed in a placeholder
	 *
	 * @param 	object		The article object.  Note $article->text is also available
	 * @param 	object		The article params
	 * @param 	int			The 'page' number
	 * @return	string
	 */
	function onBeforeDisplayContent( &$article, &$params, $limitstart )
	{
		global $mainframe;           
                return '';
	}

	/**
	 * Socialshareandvotebutton after display content method
	 *
	 * Method is called by the view and the results are imploded and displayed in a placeholder
	 *
	 * @param 	object		The article object.  Note $article->text is also available
	 * @param 	object		The article params
	 * @param 	int			The 'page' number
	 * @return	string
	 */
	function onAfterDisplayContent( &$article, &$params, $limitstart )
	{
		global $mainframe;

		return '';
	}

	/**
	 * Socialshareandvotebutton before save content method
	 *
	 * Method is called right before content is saved into the database.
	 * Article object is passed by reference, so any changes will be saved!
	 * NOTE:  Returning false will abort the save with an error.
	 * 	You can set the error by calling $article->setError($message)
	 *
	 * @param 	object		A JTableContent object
	 * @param 	bool		If the content is just about to be created
	 * @return	bool		If false, abort the save
	 */
	function onBeforeContentSave( &$article, $isNew )
	{
		global $mainframe;

		return true;
	}

	/**
	 * Socialshareandvotebutton after save content method
	 * Article is passed by reference, but after the save, so no changes will be saved.
	 * Method is called right after the content is saved
	 *
	 *
	 * @param 	object		A JTableContent object
	 * @param 	bool		If the content is just about to be created
	 * @return	void
	 */
	function onAfterContentSave( &$article, $isNew )
	{
		global $mainframe;

		return true;
	}

        

}

class Printbutton{        
    
    function show_fb_button($link, $title,$pos = 1, $style = 'normal')
    {
        $button= '';
        if($style == 'normal'){$style =  'box_count';   }
        else $style = 'button_count';
        $button = '<a name="fb_share" type="'.$style.'" share_url="'.$link.'" href="http://www.facebook.com/sharer.php">Share</a>';
        $button .= '<script src="http://static.ak.fbcdn.net/connect.php/js/FB.Share" type="text/javascript"></script>';
        $button = '<div class="allshare_button">'.$button.'</div>';
        return $button;
    }

    function show_twitter_button($link, $title, $source, $pos = 1, $style = 'normal')
    {
        $button= '';
        if($style == 'normal'){$style =  'vertical';   }
        else $style = 'horizontal';
        if($source != '') {$source = 'data-via="'.$source.'"';}
        $button = '<script type="text/javascript" src="http://platform.twitter.com/widgets.js"></script>';
        $button .= '<div><a href="http://twitter.com/share" class="twitter-share-button" data-text="'.$title.'" data-url="'.$link.'" '.$source.' data-count="'.$style.'">Tweet</a></div>';
        $button = '<div class="allshare_button">'.$button.'</div>';
        return $button;
    }

    function show_tmeme_button($link, $title, $source, $pos = 1, $style = 'normal')
    {
        $button= '';
        if($style == 'normal'){$style =  'normal';   }
        else $style = 'compact';
        $button = '<script type="text/javascript">tweetmeme_url = "'.$link.'"; tweetmeme_style = "'.$style.'"; tweetme_title = "'.$title.'"; tweetmeme_source = "'.$source.'";</script>';
        $button .= '<script type="text/javascript" src="http://tweetmeme.com/i/scripts/button.js"></script>';
        $button = '<div class="allshare_button">'.$button.'</div>';
        return $button;
    }

    function show_fbme_button($link, $title,$pos = 1, $style = 'normal')
    {
        $button= '';
        if($style == 'normal'){$style =  'large';   }
        else $style = 'small';
        $button = '<script>var fbShare = {url: "'.$link.'",title:"'.$title.'",size: "'.$style.'"}</script>';
        $button .= '<script src="http://widgets.fbshare.me/files/fbshare.js"></script>';
        $button = '<div class="allshare_button">'.$button.'</div>';
        return $button;
    }

    function show_gbuzz_button($link, $title,$pos = 1, $style = 'normal')
    {
        $button= '';
        if($style == 'normal'){$style =  'normal-count';   }
        else $style = 'small-count';
        $button = '<a title="Post to Google Buzz" class="google-buzz-button" href="http://www.google.com/buzz/post" data-button-style="'.$style.'" data-url="'.$link.'"></a>';
        $button .= '<script type="text/javascript" src="http://www.google.com/buzz/api/button.js">';
        $button = '<div class="allshare_button">'.$button.'</div>';
        return $button;
    }

    function show_ybuzz_button($link, $title,$pos = 1, $style = 'normal')
    {
        $button= '';
        if($style == 'normal'){$style =  'square';   }
        else $style = 'text-votes';        
        $button = '<script type="text/javascript" src="http://d.yimg.com/ds/badge2.in.js" badgetype="'.$style.'">'.$link.'</script>';
        $button = '<div class="allshare_button">'.$button.'</div>';
        return $button;
    }

    function show_topsy_button($link, $title, $source,$pos = 1, $style = 'normal')
    {
        $button= '';
        if($style == 'normal'){$style =  'big';   }
        else $style = 'small';
        $button = '<script type="text/javascript">  var topsy_nick = "'.$source.'";     var topsy_style = "'.$style.'";     var topsy_url = "'.$link.'";     var topsy_title = "'.$title.'";</script>';
        $button .= '<script type="text/javascript" src="http://cdn.topsy.com/button.js"></script>';
        $button = '<div class="allshare_button">'.$button.'</div>';
        return $button;
    }

    function show_digg_button($link, $title, $pos = 1, $style = 'normal')
    {
        $button= '';
        //http://about.digg.com/downloads/button/smart
        if($style == 'normal'){$style =  'DiggMedium';   }
        else $style = 'DiggCompact';
        //$button = '<script type="text/javascript" src="http://widgets.digg.com/buttons.js"></script>';
        $button = '<a class="DiggThisButton '.$style.'" href="http://digg.com/submit?url='.urlencode($link).'&amp;title='.$title.'"></a>';
        $button = '<div class="allshare_button">'.$button.'</div>';
        return $button;
    }

    function show_stumble_button($link, $title, $pos = 1, $style = 'normal')
    {
        $button= '';
        if($style == 'normal'){$style =  '5';   }
        else $style = '1';
        $button = '<script src="http://www.stumbleupon.com/hostedbadge.php?s='.$style.'&r='.$link.'"></script>';
        $button = '<div class="allshare_button">'.$button.'</div>';
        return $button;
    }

    function show_del_button($link, $title, $pos = 1, $style = 'normal')
    {        
        $button= '';
        if($style == 'normal')
        {
            $button = '<div class="allshare_button_del"><div class="allshare_button_dellshare"><a href="http://www.delicious.com/save" onclick="window.open(\'http://www.delicious.com/save?v=5&noui&jump=close&url=\'+encodeURIComponent(\''.$link.'\')+\'&title=\'+encodeURIComponent(\''.$title.'\'),\'delicious\', \'toolbar=no,width=550,height=550\'); return false;"><span>Share</span></a></div></div>';
            $button = '<div class="allshare_button">'.$button.'</div>';
        }
        else
        {
            $button = '<div class="allshare_button_delc"><div class="allshare_button_dellsharec"><a href="http://www.delicious.com/save" onclick="window.open(\'http://www.delicious.com/save?v=5&noui&jump=close&url=\'+encodeURIComponent(\''.$link.'\')+\'&title=\'+encodeURIComponent(\''.$title.'\'),\'delicious\', \'toolbar=no,width=550,height=550\'); return false;"><span>Share</span></a></div></div>';
            $button = '<div class="allshare_button">'.$button.'</div>';
        }
        
        return $button;
    }
    
    function show_dzone_button($link, $title, $pos = 1, $style = 'normal')
    {
        $button= '';
        if($style == 'normal'){$style =  '1';   }
        else $style = '2';
        $button = '<script type="text/javascript">  var dzone_url = "'.$link.'";     var dzone_title = "'.$title.'"; var dzone_style = "'.$style.'";</script>';
        $button .= '<script type="text/javascript" src="http://widgets.dzone.com/links/widgets/zoneit.js"></script>';
        $button = '<div class="allshare_button">'.$button.'</div>';
        return $button;
    }
    function show_fblike_button($link, $title, $pos = 1, $style = 'standard', $verb= 'like' , $color= 'light', $width = 450, $height = 80)
    {
        $button =  '<iframe src="http://www.facebook.com/plugins/like.php?href='.urlencode($link).'&amp;layout='.$style.'&amp;show_faces=true&amp;width='.$width.'&amp;action='.$verb.'&amp;colorscheme='.$color.'&amp;height='.$height.'" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:'.$width.'px; height:'.$height.'px;" allowTransparency="true"></iframe>';
        $button = '<div class="allshare_button_like" style="width:'.$width.'px;height:'.$height.'px;">'.$button.'</div>';
        return $button;
    }
}
